#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <ctype.h>

#include "general.h"
#include "fileoutput.h"

/*

Ringtone Tools - Copyright 2001-2005 Michael Kohn (mike@mikekohn.net)
This falls under the Kohnian license.  Please read
it at http://ringtonetools.mikekohn.net/

This program is NOT opensourced.  You may not use any part
of this program for your own software.

*/

extern int pushback;
extern int gettoken(FILE *fp, char *token, int flag);

int get_3210_tempo(FILE *fp)
{
int marker;
char token[100];
int t,ch;

  marker=ftell(fp);
  gettoken(fp,token,1);

  if (strcasecmp(token,"tempo")!=0)
  {
    pushback=-1;
    fseek(fp,marker,0);
    return 63;
  }

  gettoken(fp,token,1);
  if (strcmp(token,"=")!=0) printf("Expecting '=' and got '%s'\n",token);
  gettoken(fp,token,1);

  t=atoi(token);
  if (t<1) return 63;

  while (1)
  {
    ch=getc(fp);
    if (ch=='\n' || ch=='\r' || ch==':' || ch=='\t') continue;
    if (ch==EOF) { printf("Premature end of file\n"); break; }
      else
    {
      ungetc(ch,fp);
      break;
    }
  }

  return t;
}

int parse_3210(FILE *in, FILE *out, int out_type, struct note_t *note)
{
char token[16];
int t,l,ch,f;
int tone_modifier;

  l=0; t=0; f=0;
  if (note->songname[0]!=0) t=1;
  while(1)
  {
    ch=getc(in);
    if (f==0 && (ch=='\n' || ch=='\r')) continue;
    if (ch==':' || ch=='\n' || ch=='\r') break;
    f=1;
    if (ch==EOF)
    {
      printf("Error: Illegal keypress format file\n");
      return -1;
    }

    if (l<SONGNAME_LEN-1 && t==0) note->songname[l++]=ch;
  }

  if (t!=0) note->songname[l]=0;

  note->bpm=get_3210_tempo(in);

#ifdef DEBUG
  printf("\n       Song Name: %s\n",note->songname);
  printf("Beats Per Minute: %d\n",note->bpm);
#endif

  header_route(out,note,0,out_type);

  while(1)
  {
    tone_modifier=0;
    note->modifier=0;

    t=gettoken(in,token,1);
    if (t==-1) 
    { break; } 

    if (token[0]==':') continue;

    note->length=atoi(token);

    if (note->length==1) note->length=0;
      else
    if (note->length==2) note->length=1;
      else
    if (note->length==4) note->length=2;
      else
    if (note->length==8) note->length=3;
      else
    if (note->length==16) note->length=4;
      else
    if (note->length==32) note->length=5;

    while(1)
    {
      t=gettoken(in,token,1);

      if (strcmp(token,".")==0)
      { note->modifier++; }
        else
      if (strcmp(token,"#")==0)
      { tone_modifier++; }
        else
      { break; }
    }

    token[0]=tolower(token[0]);

    if (token[0]=='p' || token[0]=='-') note->tone=0;
      else
    if (token[0]=='a') note->tone=10;
      else
    if (token[0]=='h' || token[0]=='b') note->tone=12;
      else
    if (token[0]=='c') note->tone=1;
      else
    if (token[0]=='d') note->tone=3;
      else
    if (token[0]=='e') note->tone=5;
      else
    if (token[0]=='f') note->tone=6;
      else
    if (token[0]=='g') note->tone=8;

    note->tone=note->tone+tone_modifier;

    if (note->tone!=0)
    {
      t=gettoken(in,token,1);
      note->scale=atoi(token)-1;
    }

    if (note->tone>12)
    {
      note->tone=note->tone-12;
      note->scale++;
    }

    note_route(out,note,0,out_type);
  }

  footer_route(out,note,0,out_type);

  return (0);
}



