#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <ctype.h>

#include "general.h"
#include "fileoutput.h"

/*

Ringtone Tools - Copyright 2001-2005 Michael Kohn (mike@mikekohn.net)
This falls under the Kohnian license.  Please read
it at http://ringtonetools.mikekohn.net/

This program is NOT opensourced.  You may not use any part
of this program for your own software.

*/

int parse_morsecode(FILE *in, FILE *out, int out_type, struct note_t *note)
{
int ch,s,t;
char *p;
char code_alpha[50][5]={".-","-...","-.-.","-..",".","..-.","--.", /* A - G */
                   "....","..",".---","-.-",".-..","--",      /* H - M */
                   "-.","---",".--.","--.-",".-.","...","-",  /* N - T */
                   "..-","...-",".--","-..-","-.--","--.." }; /* U - Z */
char code_numbers[14][7]={"-----",".----","..---","...--","....-", /* 0 - 4 */
                     ".....","-....","--...","---..","----.", /* 5 - 9 */
                     ".-.-.-","--..--","..--.."," " };        /* Stop , ? */

  header_route(out,note,0,out_type);
  note->scale=0;
  note->modifier=0;
  note->tone=1;

  while ((ch=getc(in))!=EOF)
  {
    ch=tolower(ch);
    if (ch>='a' && ch <='z') p=code_alpha[ch-'a'];
      else
    if (ch>='0' && ch <='9') p=code_numbers[ch-'0'];
      else
    if (ch==',') p=code_numbers[11];
      else
    if (ch=='?') p=code_numbers[12];
      else
    if (ch=='$') p=code_numbers[10];  /* Full Stop? */
      else
    if (ch==' ') p=code_numbers[13];
      else
    { continue; }

    s=strlen(p);

    for (t=0; t<s; t++)
    {
      if (p[t]=='-')
      {
        note->length=3;
        note->tone=9;
        note->modifier=1;
        note_route(out,note,0,out_type);
      }
        else
      if (p[t]=='.')
      {
        note->length=4;
        note->tone=9;
        note->modifier=0;
        note_route(out,note,0,out_type);
/*
        note->length=4;
        note->tone=0;
        note_route(out,note,0,out_type);
*/
      }
        else
      if (p[t]==' ')
      {
        note->length=3;
        note->tone=0;
        note->modifier=1;
        note_route(out,note,0,out_type);
      }
    }
  }

  footer_route(out,note,0,out_type);

  return (0);
}



