#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include "general.h"
#include "fileoutput.h"

/*

Ringtonetools - Copyright 2001-2005 Michael Kohn (mike@mikekohn.net)
This falls under the Kohnian license.  Please read
it at http://ringtonetools.mikekohn.net/

This program is NOT opensourced.  You may not use any part
of this program for your own software.

*/

/* RTTTL and RTX */

#define DEFAULT_LENGTH 2

void write_rtttl_header(FILE *out, struct note_t *note)
{
  if (note->songname[0]==0)
  { strcpy(note->songname,"unamed"); }

  if (note->channels==0)
  { fprintf(out,"%s:d=%d,o=5,b=%d:",note->songname,1<<DEFAULT_LENGTH,note->bpm); }
    else
  {
    if (note->loop==0)
    { fprintf(out,"%s:d=%d,o=4,b=%d:",note->songname,1<<DEFAULT_LENGTH,note->bpm); }
      else
    { fprintf(out,"%s:d=%d,o=4,b=%d,l=%d:",note->songname,1<<DEFAULT_LENGTH,note->bpm,note->loop); }
  }
}

void write_rtttl_note(FILE *out, struct note_t *note)
{
  if (note->note_count>0) fprintf(out,",");

  if (note->length!=DEFAULT_LENGTH) fprintf(out,"%d",(1<<(note->length)));

  if (note->tone==0) fprintf(out,"p");
    else
  if (note->tone==1) fprintf(out,"c");
    else
  if (note->tone==2) fprintf(out,"c#");
    else
  if (note->tone==3) fprintf(out,"d");
    else
  if (note->tone==4) fprintf(out,"d#");
    else
  if (note->tone==5) fprintf(out,"e");
    else
  if (note->tone==6) fprintf(out,"f");
    else
  if (note->tone==7) fprintf(out,"f#");
    else
  if (note->tone==8) fprintf(out,"g");
    else
  if (note->tone==9) fprintf(out,"g#");
    else
  if (note->tone==10) fprintf(out,"a");
    else
  if (note->tone==11) fprintf(out,"a#");
    else
  if (note->tone==12) fprintf(out,"h");

  if (note->tone!=0)
  {
    if (note->channels==0)
    { if (note->scale!=0) fprintf(out,"%d",note->scale+5); }
      else
    { if (note->scale!=0) fprintf(out,"%d",note->scale+4); }
  }

  if (note->modifier!=0) fprintf(out,".");
}

void write_rtttl_footer(FILE *out, struct note_t *note)
{
  /* fprintf(out,";"); */
}

void write_rtx_bpm(FILE *out, struct note_t *note)
{
  if (note->note_count>0) fprintf(out,",");
  fprintf(out,"b=%d",note->bpm);
}


